#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:
#
# Author:      TRYKOWSKI
#
# Created:     30/10/2011
# Copyright:   (c) TRYKOWSKI 2011
# Licence:     <your licence>
#-------------------------------------------------------------------------------
#!/usr/bin/env python

from math import *
from random import *

# FONCTION DONT ON CHERCHE UNE RACINE
def f(x):

    fx=exp(x)-5

    return fx

# nombre d?riv?
def derive(f,a):
    eps=0.00001
    df=(f(a+eps)-f(a))/eps

    return(df)


#Dichotomoie racine ds [a;b] ; eps=pr?cision ; compteur = nbre de boucles
def dicho(a,b,eps):
    compteur=1
    while abs(f(a))>eps:
        c=(a+b)/2.
        if f(a)*f(c)<=0:
            b=c
        else:
            a=c
        compteur=compteur+1

    return(a,compteur)

#version recursive
def dichorec(a,b,eps,compteur):
    c=(a+b)/2.
    if abs(f(a))>eps:
        if f(a)*f(c)<=0:
            return(dichorec(a,c,eps,compteur+1))
        else:
            return(dichorec(c,b,eps,compteur+1))
    else:
        return(c,compteur)



#Newton a=d?part ; eps=pr?cision ; compteur=nombre de boucles
def newton(a,eps):
    compteur=1
    while (abs(f(a))>eps)and(derive(f,a))!=0 :
        a=-f(a)/derive(f,a)+a+0.
        compteur=compteur+1

    return(a,compteur)


#Newton a=d?part ; eps=pr?cision ; compteur=nombre de boucles
def newtonrec(a,eps,compteur):

    if (abs(f(a))>eps)and(derive(f,a))!=0:
        return(newtonrec(-f(a)/derive(f,a)+a+0.,eps,compteur+1))
    else:
        return(a,compteur)


def montecarlo(a,b,eps,maxiter):
    compteur=1
    c=randint(a,b)
    while ( abs(f(c))>eps )and( compteur<maxiter):
        c=(b-a)*random()+a
        compteur=compteur+1
    return(c,compteur)


print 'dicho:',dicho(-1,5,0.000001)
print 'dichorec:',dichorec(-1,5,0.000001,1)
print 'newtow:',newton(3,0.00000001)
print 'newtonrec:',newtonrec(3,0.00000001,1)
print 'montecarlo:',montecarlo(-1,5,0.000001,10000000)